#-----------------------------------------------------------------------------
%{?!dist:	%define	dist	.ok}
%define		arg		argon2
#-----------------------------------------------------------------------------
Name		:	phc-winner-argon2
Version		:	20190702
Release		:	16.2.0.rel%{?dist}
Summary		:	Reference C implementation of Argon2

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	Apache Public License 2.0
URL		:	https://github.com/P-H-C/phc-winner-argon2

Source0		:	%{name}-%{version}.tar.gz

#-----------------------------------------------------------------------------
#-----------------------------------------------------------------------------
%description
This is the reference C implementation of Argon2, the
password-hashing function that won the Password Hashing
Competition (PHC).

Argon2 is a password-hashing function that summarizes
the state of the art in the design of memory-hard functions
and can be used to hash passwords for credential storage,
key derivation, or other applications.

It has a simple design aimed at the highest memory filling
rate and effective use of multiple computing units, while
still providing defense against tradeoff attacks (by
exploiting the cache and memory organization of the recent
processors).

Argon2 has three variants: Argon2i, Argon2d, and Argon2id.
Argon2d is faster and uses data-depending memory access,
which makes it highly resistant against GPU cracking attacks
and suitable for applications with no threats from side-channel
timing attacks (eg. cryptocurrencies). Argon2i instead uses
data-independent memory access, which is preferred for password
hashing and password-based key derivation, but it is slower
as it makes more passes over the memory to protect from tradeoff
attacks. Argon2id is a hybrid of Argon2i and Argon2d, using
a combination of data-depending and data-independent memory
accesses, which gives some of Argon2i's resistance to
side-channel cache timing attacks and much of Argon2d's
resistance to GPU cracking attacks.


#-----------------------------------------------------------------------------
%prep
%setup -q

#-----------------------------------------------------------------------------
#building application
%build

%define _smp_mflags -j%(/usr/bin/getconf _NPROCESSORS_ONLN)
%{__make}						\
	PREFIX=""					\
	BINARY_REL=%{_bindir}				\
	INCLUDE_REL=%{_includedir}			\
	LIBRARY_REL=%{_libdir}				\
	%{_smp_mflags}

#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#-----------------------------------------------------------------------------
#installing program
%install
%{__rm} -rf %{buildroot}

%{__make}						\
	PREFIX=""					\
	BINARY_REL=%{_bindir}				\
	INCLUDE_REL=%{_includedir}			\
	LIBRARY_REL=%{_libdir}				\
	DESTDIR="%{buildroot}"				\
	install

%{__chmod} +x %{buildroot}/%{_libdir}/*.so.*

#To remove libtool library
find 							\
	%{buildroot}%{_libdir}				\
	-name \*.a					\
	-delete

#-----------------------------------------------------------------------------
%files			
%defattr(-,root,root,-)
%doc LICENSE README.md
%{_bindir}/%{arg}
%{_includedir}/%{arg}.h
%{_libdir}/lib%{arg}.so*
%{_libdir}/pkgconfig/lib%{arg}.pc

#-----------------------------------------------------------------------------
%postun
/usr/sbin/ldconfig

%post
/usr/sbin/ldconfig

#-----------------------------------------------------------------------------
%changelog
